#neutral building highlighter and addbordercolor
#builds a command string for image magick and then passes that command string to image magic via command line
#Following must be done beforehand

#1)  All maps you want to modify must be unpacked in a folder(F). 
#    No other unpacked maps, which you don't want to modify must be in the same folder!!!
#2) run the following command in the windows shell in folder F
#   dir /a:-D/b/s > ListofAllSubFiles.txt
#   it creates a list of all files in all subfolders of folder F
#3) place this file in the folder F
#4) install image magick https://imagemagick.org/script/index.php
#5) run this python script with python 3 installed https://www.python.org/downloads/
#    type highlightNeutralBuildings_v3.py in command shell(nice debug messages) or double click

#Settings:
HighlightNeutrals=True # highlights hospitals and derricks
ExtendedMode=False # also highlights fcom(forward command) and miss (science building)
#you can also set the colors and types of the neutral buildings recognized in the code

#------------------------------
import subprocess
import sys

#selects the locations of map.pngs in ListofAllSubFiles.txt and puts them in a list
Filelist=[]
File = open("ListofAllSubFiles.txt", "r")
for locationtext in File:
    if locationtext[-8:]=="map.png\n":
        Filelist.append(locationtext[:-8])
    else:
        continue
File.close()

for location in Filelist:
    print(location)
    MapPreviewFile=location+"map.png"
    File = open(location+"map.yaml", "r")    
    
    #WRITE THE NEUTRAL BUILDINGS HIGHLIGHT COMMAND FOR IMAGE MAGIC
    ColorCommand="fill white"
    CommandText=''
    firstentry=True
    target=1
    for line in File:
        LineArray = line.split()
        if len(LineArray)>1 and LineArray[0]=="Bounds:": #get the actual map bounds which define the 0,0 pixels of the map.png
            mapstartx=int(LineArray[1].split(",")[0])
            mapstarty=int(LineArray[1].split(",")[1])
            width=int(LineArray[1].split(",")[2])
            height=int(LineArray[1].split(",")[3])
            MapSize=str(width)+"x"+str(height)
            print(MapSize)
            
        if len(LineArray)>1:
            T = LineArray[1]
        else:
            T="N/A"   
        if T=="oilb":
            print("oilb")
            target=-2
            size=[2,2]
            ColorCommand="fill white"
        if T=="hosp":
            print("hosp")
            target=-2
            size=[2,2]
            ColorCommand="fill white"
        if ExtendedMode and T=="miss":
            print("miss")
            target=-2
            size=[3,2]
            ColorCommand="fill white"
        if ExtendedMode and T=="fcom":
            print("fcom")
            target=-2
            size=[2,2]
            ColorCommand="fill white"
            
        if target <= 0 and LineArray[0]=="Location:": #this fails(no dots) if Location isn't in the first 2 enries 
            PosLine = LineArray[1].split(",")
            xpos=int(PosLine[0])
            ypos=int(PosLine[1])
            #command text is appended sth like    " fill white"
            if firstentry:
                CommandText=CommandText+ColorCommand
                firstentry=False
            else:
                CommandText=CommandText+" "+ColorCommand
            for i in range(size[0]):
                for j in range(size[1]):
                    #command text is appended sth like    " color 15,16 point"
                    CommandText=CommandText+" "+"color "+str(xpos+i-mapstartx)+","+str(ypos+j-mapstarty)+" point"               
        target=target+1
    File.close()
    
    
    #USE THE NEUTRAL BUILDINGS HIGHLIGHT COMMAND
    #call image magick
    if HighlightNeutrals:
        subprocess.call(['magick','convert',MapPreviewFile,'-draw',CommandText,MapPreviewFile])